<?php

/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@magentocommerce.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade Magento to newer
 * versions in the future. If you wish to customize Magento for your
 * needs please refer to http://www.magentocommerce.com for more information.
 *
 * @category    Mage
 * @package     Mage_Page
 * @copyright   Copyright (c) 2014 Magento Inc. (http://www.magentocommerce.com)
 * @license     http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */


/**
 * Html page block
 *
 * @category   Mage
 * @package    Mage_Page
 * @author     Magento Core Team <core@magentocommerce.com>
 */
class Gala_Galatitanshopsettings_Block_Html_Head extends Mage_Page_Block_Html_Head
{
    public function addEMItem($type, $name, $params = null, $if = null, $cond = null)
    {
        if ($type == 'lesscss') {			
			$_lessCacheId = 'galatitanshop_less_cache_store_'.Mage::app()->getStore()->getCode();
			$_newLessConfig = Mage::helper('galatitanshopsettings')->getAllCssConfig();
			if (false !== ($data = Mage::app()->getCache()->load($_lessCacheId))) {
				$_oldLessConfig = unserialize($data);				
				if (count(array_diff_assoc($_newLessConfig, $_oldLessConfig)) > 0) {
					$_hasChange = true;				
					Mage::app()->getCache()->remove($_lessCacheId);
					Mage::app()->getCache()->save(serialize($_newLessConfig), $_lessCacheId, array('GALATITANSHOP_LESS_CSS_CACHE'), 86400);
				}else{
					$_hasChange = false;		
				}
			} else {
				$_hasChange = true;	
				Mage::app()->getCache()->save(serialize($_newLessConfig), $_lessCacheId, array('GALATITANSHOP_LESS_CSS_CACHE'), 86400);
			}			
			$pathFile = Mage::getBaseDir('media') . DS . 'galatitanshop' . DS . 'css' . DS . 'less' . DS . 'variables_store_'.Mage::app()->getStore()->getCode().'.less';					
			if ($_hasChange == true || !file_exists($pathFile)) {
				$stringless = '';
				if (isset($_newLessConfig['@function_url'])) {
					foreach (explode(',', $_newLessConfig['@function_url']) as $file) {
						$stringless .= '@import ' . $file . ';';
					}
				}
				if (isset($_newLessConfig['@variables_url'])) {
					foreach (explode(',', $_newLessConfig['@variables_url']) as $file) {
						$stringless .= '@import ' . $file . ';';
					}
				}
				if (isset($_newLessConfig['additional_css_file'])) {
					foreach ($_newLessConfig['additional_css_file'] as $file) {
						$stringless .= '@import ' . $file . ';';
					}
				}

				foreach ($_newLessConfig as $typo => $value) {
					if ($typo != 'additional_css_file') {
						$stringless .= $typo . ":" . $value . ';';
					}

				}
				file_put_contents($pathFile, $stringless);
			}			
            $href = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA).'galatitanshop/css/less/variables_store_'.Mage::app()->getStore()->getCode().'.less';
            $this->addItem('link_rel', $href, 'rel="stylesheet/less" type="text/css"');
        } else {
            if ($type == 'em_js') {
                $href = $this->getSkinUrl($name);
                $this->addItem($type, $href, $params, $if, $cond);
            } else {
				$this->addItem($type, $name, $params, $if, $cond);
            }

        }
    }

    protected function _separateOtherHtmlHeadElements(&$lines, $itemIf, $itemType, $itemParams,
        $itemName, $itemThe)
    {
        $params = $itemParams ? ' ' . $itemParams : '';
        $href = $itemName;
        switch ($itemType) {
            case 'rss':
                $lines[$itemIf]['other'][] = sprintf('<link href="%s"%s rel="alternate" type="application/rss+xml" />',
                    $href, $params);
                break;
            case 'link_rel':
                $lines[$itemIf]['other'][] = sprintf('<link%s href="%s" />', $params, $href);
                break;

            case 'em_js':
                $lines[$itemIf]['other'][] = sprintf('<script type="text/javascript" src="%s" %s></script>',
                    $href, $params);
                break;

        }
    }


}
