<?php
class EM_LayeredNavigation_Block_Catalog_Breadcrumbs extends Mage_Core_Block_Template
{
	/**
     * Retrieve HTML title value separator (with space)
     *
     * @param mixed $store
     * @return string
     */
    public function getTitleSeparator($store = null)
    {
        $separator = (string)Mage::getStoreConfig('catalog/seo/title_separator', $store);
        return ' ' . $separator . ' ';
    }

    /**
     * Preparing layout
     *
     * @return Mage_Catalog_Block_Breadcrumbs
     */
    protected function _prepareLayout()
    {
        if ($breadcrumbsBlock = $this->getLayout()->getBlock('breadcrumbs')) {
            $breadcrumbsBlock->addCrumb('home', array(
                'label'=>Mage::helper('catalog')->__('Home'),
                'title'=>Mage::helper('catalog')->__('Go to Home Page'),
                'link'=>Mage::getBaseUrl()
            ));

            $title = array();
            $path  = Mage::helper('layerednavigation/breadcrumbs')->getBreadcrumbPath();

            foreach ($path as $name => $breadcrumb) {
                $breadcrumbsBlock->addCrumb($name, $breadcrumb);
                $title[] = $breadcrumb['label'];
            }
			
            if ($headBlock = $this->getLayout()->getBlock('head')) {
				if(Mage::helper('layerednavigation/breadcrumbs')->getCategory() && Mage::helper('layerednavigation/breadcrumbs')->getCategory()->getMetaTitle()){
					$headBlock->setTitle(Mage::helper('layerednavigation/breadcrumbs')->getCategory()->getMetaTitle());
				} else {
					$headBlock->setTitle(join($this->getTitleSeparator(), array_reverse($title)));
				}
            }
        }
        return parent::_prepareLayout();
    }
}
