<?php

class EM_Megamenupro_Block_Adminhtml_Megamenupro_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{
  protected function _prepareForm()
  {
      $form = new Varien_Data_Form();
      $this->setForm($form);
      $fieldset = $form->addFieldset('megamenupro_form', array('legend'=>Mage::helper('megamenupro')->__('Item information')));
     
      $fieldset->addField('name', 'text', array(
          'label'     => Mage::helper('megamenupro')->__('Name'),
          'class'     => 'required-entry',
          'required'  => true,
          'name'      => 'name',
      ));
	  
	  $fieldset->addField('identifier', 'text', array(
		  'label'     => Mage::helper('megamenupro')->__('Identifier'),
		  'title'     => Mage::helper('megamenupro')->__('Identifier'),
		  'class'     => 'validate-xml-identifier',
		  'required'  => true,
		  'name'      => 'identifier',
		));

		$fieldset->addField('description', 'textarea', array(
			'label' 	=> Mage::helper('megamenupro')->__('Description'),
			'class' 	=> 'required-entry',
			'style'		=> 'width:60em',
			'required'	=> true,
			'name' 		=> 'description',
		));

	  $fieldset->addField('type', 'select', array(
          'label'     => Mage::helper('megamenupro')->__('Type'),
          'name'      => 'type',
          'values'    => array(
              array(
                  'value'     => 0,
                  'label'     => Mage::helper('megamenupro')->__('Horizontal'),
              ),

              array(
                  'value'     => 1,
                  'label'     => Mage::helper('megamenupro')->__('Vertical'),
              ),
          ),
      ));
		
      $fieldset->addField('status', 'select', array(
          'label'     => Mage::helper('megamenupro')->__('Status'),
          'name'      => 'status',
          'values'    => array(
              array(
                  'value'     => 1,
                  'label'     => Mage::helper('megamenupro')->__('Enabled'),
              ),
              array(
                  'value'     => 0,
                  'label'     => Mage::helper('megamenupro')->__('Disabled'),
              ),
          ),
      ));

	 $fieldset->addField('css_class', 'text', array(
          'label'     => Mage::helper('megamenupro')->__('Custom CSS Class'),
          'class'     => '',
          'name'      => 'css_class',
      ));

	  $fieldset->addField('content', 'textarea', array(
          'style'     => 'display:none',
          'name'      => 'content',
      ));

      if ( Mage::getSingleton('adminhtml/session')->getMegamenuproData() )
      {
          $form->setValues(Mage::getSingleton('adminhtml/session')->getMegamenuproData());
          Mage::getSingleton('adminhtml/session')->setMegamenuproData(null);
      } elseif ( Mage::registry('megamenupro_data') ) {
          $form->setValues(Mage::registry('megamenupro_data')->getData());
      }
      return parent::_prepareForm();
  }
}